#!/bin/bash

function run_program()
{
# This function runs the iterator program

	# Remove left over running file
	rm -f running

	# Write to logfile
	echo "" >> logfile
	date >> logfile
	echo "Running iterator with ${@}" >> logfile

	# Run iterator with passed arguments
	./iterator "${@}" > "stdout-${4}"

	# Rename output file
	mv output.dat "output-${4}.dat"

	# Remove left over running file
	rm -f running

	# Write to logfile
	echo "Output file: output-${4}.dat" >> logfile
	echo "Standard output: stdout-${4}" >> logfile
}

# Parameters that stay the same each run
myFIXED_PARAMS="100 100 1000"

# Run iterator program once for each argument
#  Note: *no* quotes around ${myFIXED_PARAMS}
#        or they'll be interpreted as one argument!
for zzARGS in "${@}" ; do
	run_program ${myFIXED_PARAMS} "${zzARGS}"
done
