#!/bin/bash
set -e

function run_program()
{
# This function runs the iterator program

	# Remove left over running file
	rm -f running

	# Write to logfile
	echo "" >> "${myLOGFILE}"
	date >> "${myLOGFILE}"
	echo "Running ${myPROG} with ${@}" >> "${myLOGFILE}"

	# Run program with passed arguments
	"${myPROG}" "${@}" > "stdout-${1}-${2}-${3}-${4}"

	# Rename output file
	mv output.dat "output-${1}-${2}-${3}-${4}.dat"

	# Remove left over running file
	rm -f running

	# Write to logfile
	echo "Output file: output-${1}-${2}-${3}-${4}.dat" >> "${myLOGFILE}"
	echo "Standard output: stdout-${1}-${2}-${3}-${4}" >> "${myLOGFILE}"
}

# Program to run: iterator
myPROG="$(pwd -P)/iterator"

# My current directory
myDIR="$(pwd -P)"

# Location of log file
myLOGFILE="${myDIR}/logfile"

# Temporary directory for me to work in
myTEMP_DIR="$(mktemp -t -d iterator.XXXXXXXXX)"

# Change to temporary directory
cd "${myTEMP_DIR}"

# Read in parameters from standard input
#   and then run program with them
#   and run it again and again until there are no more
while read myNX myNY myN_ITER myEPSILON myJUNK ; do

	# Run program
	run_program "${myNX}" "${myNY}" "${myN_ITER}" "${myEPSILON}"

done

# Copy files back to my directory
cp -fpR . "${myDIR}"

# Go back to my directory
cd "${myDIR}"

# Clean up
rm -Rf "${myTEMP_DIR}"
